import { jsx as _jsx } from "@emotion/react/jsx-runtime";
import React from "react";
import { VariablesProvider } from "@qorebase/app-component";
import dot from "dot-object";
export function itemVariableValues(variables) {
    const itemIds = dot.dot(variables);
    return Object.fromEntries(Object.entries(itemIds).map(([key, value]) => [
        // replace array bracket syntax into dot syntax
        `item.${key.replace(/(\[|\]\.|\])/g, ".")}`,
        value,
    ]));
}
export default function ListItemVariables(props) {
    const values = React.useMemo(() => {
        return itemVariableValues(props.variables);
    }, [props.variables]);
    return (_jsx(VariablesProvider, Object.assign({ values: values }, { children: props.children })));
}
//# sourceMappingURL=ListItemVariables.js.map