import { jsx as _jsx, jsxs as _jsxs } from "@emotion/react/jsx-runtime";
import SidebarLayout from "./SidebarLayout";
import TopbarLayout from "./TopbarLayout";
export const getNavigationLayouts = () => [
    {
        value: "sidebar",
        icon: "/assets/navigation/sidebar-layout.svg",
    },
    {
        value: "topbar",
        icon: "/assets/navigation/topbar-layout.svg",
    },
];
const NavigationLayoutComponent = ({ layout, page, children }) => {
    switch (layout) {
        case "sidebar":
            return _jsx(SidebarLayout, Object.assign({ page: page }, { children: children }));
        case "topbar":
            return _jsxs(TopbarLayout, Object.assign({ page: page }, { children: [children, " "] }));
    }
};
export default NavigationLayoutComponent;
//# sourceMappingURL=index.js.map