import { __awaiter } from "tslib";
// @ts-nocheck
import React from "react";
import { componentAliases } from "./componentAliases";
import { registerComponent, getComponent, } from "./interfaces";
import { RuntimeContext } from "./RuntimeContext";
import { importNpmComponent } from "./utils/importComponent";
import { mutate } from "swr";
import useSWRImmutable from "swr/immutable";
// TODO: auto generate this variables
/* eslint-disable @typescript-eslint/no-var-requires */
export const builtinComponents = {
    "@qorebase/action-text-component": {
        version: (await import("@qorebase/action-text-component/package.json", {
            assert: { type: "json" },
        })).version,
        importComponent: () => import("@qorebase/action-text-component"),
    },
    "@qorebase/banner-component": {
        version: (await import("@qorebase/banner-component/package.json", {
            assert: { type: "json" },
        })).version,
        importComponent: () => import("@qorebase/banner-component"),
    },
    "@qorebase/bar-chart-component": {
        version: (await import("@qorebase/bar-chart-component/package.json", {
            assert: { type: "json" },
        })).version,
        importComponent: () => import("@qorebase/bar-chart-component"),
    },
    "@qorebase/barcode-component": {
        version: (await import("@qorebase/barcode-component/package.json", {
            assert: { type: "json" },
        })).version,
        importComponent: () => import("@qorebase/barcode-component"),
    },
    "@qorebase/barcode-generator-component": {
        version: (await import("@qorebase/barcode-generator-component/package.json", {
            assert: { type: "json" },
        })).version,
        importComponent: () => import("@qorebase/barcode-generator-component"),
    },
    "@qorebase/button-component": {
        version: (await import("@qorebase/button-component/package.json", {
            assert: { type: "json" },
        })).version,
        importComponent: () => import("@qorebase/button-component"),
    },
    "@qorebase/button-bar-component": {
        version: (await import("@qorebase/button-bar-component/package.json", {
            assert: { type: "json" },
        })).version,
        importComponent: () => import("@qorebase/button-bar-component"),
    },
    "@qorebase/card-component": {
        version: (await import("@qorebase/card-component/package.json", {
            assert: { type: "json" },
        })).version,
        importComponent: () => import("@qorebase/card-component"),
    },
    "@qorebase/carousel-component": {
        version: (await import("@qorebase/carousel-component/package.json", {
            assert: { type: "json" },
        })).version,
        importComponent: () => import("@qorebase/carousel-component"),
    },
    "@qorebase/container-component": {
        version: (await import("@qorebase/container-component/package.json", {
            assert: { type: "json" },
        })).version,
        importComponent: () => import("@qorebase/container-component"),
    },
    "@qorebase/date-picker-component": {
        version: (await import("@qorebase/date-picker-component/package.json", {
            assert: { type: "json" },
        })).version,
        importComponent: () => import("@qorebase/date-picker-component"),
    },
    "@qorebase/description-text-component": {
        version: (await import("@qorebase/description-text-component/package.json", {
            assert: { type: "json" },
        })).version,
        importComponent: () => import("@qorebase/description-text-component"),
    },
    "@qorebase/divider-component": {
        version: (await import("@qorebase/divider-component/package.json", {
            assert: { type: "json" },
        })).version,
        importComponent: () => import("@qorebase/divider-component"),
    },
    "@qorebase/dropdown-component": {
        version: (await import("@qorebase/dropdown-component/package.json", {
            assert: { type: "json" },
        })).version,
        importComponent: () => import("@qorebase/dropdown-component"),
    },
    "@qorebase/dropdown-list-component": {
        version: (await import("@qorebase/dropdown-list-component/package.json", {
            assert: { type: "json" },
        })).version,
        importComponent: () => import("@qorebase/dropdown-list-component"),
    },
    "@qorebase/dropdown-relation-component": {
        version: (await import("@qorebase/dropdown-relation-component/package.json", {
            assert: { type: "json" },
        })).version,
        importComponent: () => import("@qorebase/dropdown-relation-component"),
    },
    "@qorebase/embed-component": {
        version: (await import("@qorebase/embed-component/package.json", {
            assert: { type: "json" },
        })).version,
        importComponent: () => import("@qorebase/embed-component"),
    },
    "@qorebase/file-picker-component": {
        version: (await import("@qorebase/file-picker-component/package.json", {
            assert: { type: "json" },
        })).version,
        importComponent: () => import("@qorebase/file-picker-component"),
    },
    "@qorebase/floating-button-component": {
        version: (await import("@qorebase/floating-button-component/package.json", {
            assert: { type: "json" },
        })).version,
        importComponent: () => import("@qorebase/floating-button-component"),
    },
    "@qorebase/headline-component": {
        version: (await import("@qorebase/headline-component/package.json", {
            assert: { type: "json" },
        })).version,
        importComponent: () => import("@qorebase/headline-component"),
    },
    "@qorebase/hint-component": {
        version: (await import("@qorebase/hint-component/package.json", {
            assert: { type: "json" },
        })).version,
        importComponent: () => import("@qorebase/hint-component"),
    },
    "@qorebase/horizontal-tile-component": {
        version: (await import("@qorebase/horizontal-tile-component/package.json", {
            assert: { type: "json" },
        })).version,
        importComponent: () => import("@qorebase/horizontal-tile-component"),
    },
    "@qorebase/icon-button-component": {
        version: (await import("@qorebase/icon-button-component/package.json", {
            assert: { type: "json" },
        })).version,
        importComponent: () => import("@qorebase/icon-button-component"),
    },
    "@qorebase/image-component": {
        version: (await import("@qorebase/image-component/package.json", {
            assert: { type: "json" },
        })).version,
        importComponent: () => import("@qorebase/image-component"),
    },
    "@qorebase/line-chart-component": {
        version: (await import("@qorebase/line-chart-component/package.json", {
            assert: { type: "json" },
        })).version,
        importComponent: () => import("@qorebase/line-chart-component"),
    },
    "@qorebase/list-component": {
        version: (await import("@qorebase/list-component/package.json", {
            assert: { type: "json" },
        })).version,
        importComponent: () => import("@qorebase/list-component"),
    },
    "@qorebase/list-card-component": {
        version: (await import("@qorebase/list-card-component/package.json", {
            assert: { type: "json" },
        })).version,
        importComponent: () => import("@qorebase/list-card-component"),
    },
    "@qorebase/location-component": {
        version: (await import("@qorebase/location-component/package.json", {
            assert: { type: "json" },
        })).version,
        importComponent: () => import("@qorebase/location-component"),
    },
    "@qorebase/location-input-component": {
        version: (await import("@qorebase/location-input-component/package.json", {
            assert: { type: "json" },
        })).version,
        importComponent: () => import("@qorebase/location-input-component"),
    },
    "@qorebase/multiple-file-picker-component": {
        version: (await import("@qorebase/multiple-file-picker-component/package.json", {
            assert: { type: "json" },
        })).version,
        importComponent: () => import("@qorebase/multiple-file-picker-component"),
    },
    "@qorebase/number-input-component": {
        version: (await import("@qorebase/number-input-component/package.json", {
            assert: { type: "json" },
        })).version,
        importComponent: () => import("@qorebase/number-input-component"),
    },
    // "@qorebase/paragraph-component": {
    //   version: (await import("@qorebase/paragraph-component/package.json", { assert: { type: "json" } })).version,
    //   importComponent: () => import("@qorebase/paragraph-component"),
    // },
    "@qorebase/pie-chart-component": {
        version: (await import("@qorebase/pie-chart-component/package.json", {
            assert: { type: "json" },
        })).version,
        importComponent: () => import("@qorebase/pie-chart-component"),
    },
    "@qorebase/qr-code-generator-component": {
        version: (await import("@qorebase/qr-code-generator-component/package.json", {
            assert: { type: "json" },
        })).version,
        importComponent: () => import("@qorebase/qr-code-generator-component"),
    },
    "@qorebase/qr-code-scanner-component": {
        version: (await import("@qorebase/qr-code-scanner-component/package.json", {
            assert: { type: "json" },
        })).version,
        importComponent: () => import("@qorebase/qr-code-scanner-component"),
    },
    "@qorebase/rating-component": {
        version: (await import("@qorebase/rating-component/package.json", {
            assert: { type: "json" },
        })).version,
        importComponent: () => import("@qorebase/rating-component"),
    },
    "@qorebase/repeatable-container-component": {
        version: (await import("@qorebase/repeatable-container-component/package.json", {
            assert: { type: "json" },
        })).version,
        importComponent: () => import("@qorebase/repeatable-container-component"),
    },
    "@qorebase/rich-text-component": {
        version: (await import("@qorebase/rich-text-component/package.json", {
            assert: { type: "json" },
        })).version,
        importComponent: () => import("@qorebase/rich-text-component"),
    },
    // "@qorebase/rich-text-input-component": {
    //   version: (await import("@qorebase/rich-text-input-component/package.json", { assert: { type: "json" } }))
    //     .version,
    //   importComponent: () => import("@qorebase/rich-text-input-component"),
    // },
    "@qorebase/scorecard-component": {
        version: (await import("@qorebase/scorecard-component/package.json", {
            assert: { type: "json" },
        })).version,
        importComponent: () => import("@qorebase/scorecard-component"),
    },
    "@qorebase/sticky-container-component": {
        version: (await import("@qorebase/sticky-container-component/package.json", {
            assert: { type: "json" },
        })).version,
        importComponent: () => import("@qorebase/sticky-container-component"),
    },
    "@qorebase/table-component": {
        version: (await import("@qorebase/table-component/package.json", {
            assert: { type: "json" },
        })).version,
        importComponent: () => import("@qorebase/table-component"),
    },
    "@qorebase/text-component": {
        version: (await import("@qorebase/text-component/package.json", {
            assert: { type: "json" },
        })).version,
        importComponent: () => import("@qorebase/text-component"),
    },
    "@qorebase/text-area-component": {
        version: (await import("@qorebase/text-area-component/package.json", {
            assert: { type: "json" },
        })).version,
        importComponent: () => import("@qorebase/text-area-component"),
    },
    "@qorebase/text-input-component": {
        version: (await import("@qorebase/text-input-component/package.json", {
            assert: { type: "json" },
        })).version,
        importComponent: () => import("@qorebase/text-input-component"),
    },
    "@qorebase/toggle-component": {
        version: (await import("@qorebase/toggle-component/package.json", {
            assert: { type: "json" },
        })).version,
        importComponent: () => import("@qorebase/toggle-component"),
    },
    "@qorebase/vertical-tile-component": {
        version: (await import("@qorebase/vertical-tile-component/package.json", {
            assert: { type: "json" },
        })).version,
        importComponent: () => import("@qorebase/vertical-tile-component"),
    },
};
/* eslint-disable @typescript-eslint/no-var-requires */
export const useImportComponentLazy = () => {
    const npmComponents = RuntimeContext.useSelectState((state) => state.components);
    return React.useCallback((name) => __awaiter(void 0, void 0, void 0, function* () {
        var _a;
        const registeredComponent = getComponent(name);
        if (registeredComponent) {
            return registeredComponent;
        }
        const npmComponent = npmComponents.find((component) => component.name === name && component.enabled);
        if (npmComponent) {
            return (yield importNpmComponent(name, npmComponent.version)).component;
        }
        const builtinComponent = (_a = builtinComponents[name]) !== null && _a !== void 0 ? _a : builtinComponents[componentAliases[name]];
        if (!builtinComponent) {
            throw Error(`Component ${name} not found`);
        }
        return builtinComponent.importComponent().then((module) => {
            mutate(["npm components", name], module.default);
            registerComponent(name, module.default).component;
        });
    }), [npmComponents]);
};
export const useImportComponent = (name) => {
    const importComponent = useImportComponentLazy();
    const { data } = useSWRImmutable(["npm components", name], (_, name) => importComponent(name), {
        isPaused: () => !name,
        suspense: true,
    });
    return data;
};
export const importBuiltins = (ignores) => __awaiter(void 0, void 0, void 0, function* () {
    return Promise.all(Object.entries(builtinComponents)
        .filter(([name]) => !ignores.includes(name))
        .map(([name, { importComponent }]) => importComponent().then((module) => {
        mutate(["npm components", name], module.default);
        return registerComponent(name, module.default);
    })));
});
//# sourceMappingURL=builtinComponents.js.map