import { Fragment as _Fragment, jsx as _jsx } from "@emotion/react/jsx-runtime";
/* eslint-disable */
import React from "react";
class ErrorBoundary extends React.Component {
    constructor(props) {
        super(props);
        // Define a state variable to track whether is an error or not
        this.state = { hasError: false };
    }
    static getDerivedStateFromError(error) {
        // Update state so the next render will show the fallback UI
        return { hasError: true };
    }
    componentDidCatch(error, errorInfo) {
        // You can use your own error logging service here
        this.props.onError({ error, errorInfo });
    }
    render() {
        // Check if the error is thrown
        // @ts-ignore
        if (this.state.hasError) {
            // You can render any custom fallback UI
            return _jsx(_Fragment, { children: this.props.fallback });
        }
        // Return children components in case of no error
        return this.props.children;
    }
}
export default ErrorBoundary;
//# sourceMappingURL=ErrorBoundary.js.map