import { jsx as _jsx } from "@emotion/react/jsx-runtime";
import { Flex } from "@chakra-ui/react";
const VStackComponent = ({ children, properties }) => {
    const hasChildren = !!children;
    const backgroundStyle = properties.background === "fill"
        ? {
            bg: "white",
            shadow: "base",
        }
        : {
            bg: "transparent",
        };
    return (_jsx(Flex, Object.assign({ minH: hasChildren ? undefined : "50px", rounded: "lg", flex: properties.length, p: properties.padding }, backgroundStyle, { gap: properties.gap, direction: "column" }, { children: children })));
};
export default VStackComponent;
//# sourceMappingURL=VStack.js.map