export const duration = 0.1;
export const directionMotion = {
    slideRight: {
        initial: { x: "-10%" },
        animate: {
            x: 0,
            transition: {
                duration,
                ease: "easeOut",
            },
        },
        exit: {
            x: "10%",
            transition: {
                duration,
                ease: "easeIn",
            },
        },
    },
    slideLeft: {
        initial: { x: "10%" },
        animate: {
            x: 0,
            transition: {
                duration,
                ease: "easeOut",
            },
        },
        exit: {
            x: "-10%",
            transition: {
                duration: duration,
                ease: "easeIn",
            },
        },
    },
    slideUp: {
        initial: { y: "10%" },
        animate: {
            y: 0,
            transition: {
                duration,
                ease: "easeOut",
            },
        },
        exit: {
            y: "-10%",
            transition: {
                duration,
                ease: "easeIn",
            },
        },
    },
    slideDown: {
        initial: { y: "-10%" },
        animate: {
            y: 0,
            transition: {
                duration,
                ease: "easeOut",
            },
        },
        exit: {
            y: "10%",
            transition: {
                duration,
                ease: "easeIn",
            },
        },
    },
    fade: {
        initial: { opacity: 0 },
        animate: {
            x: 0,
            opacity: 1,
            transition: { duration },
        },
        exit: { opacity: 0, transition: { duration } },
    },
    scale: {
        initial: { scale: 0.5 },
        animate: {
            x: 0,
            scale: 1,
            transition: { duration },
        },
        exit: { scale: 0, transition: { duration } },
    },
    none: {
        initial: { x: 0, y: 0 },
        animate: { x: 0, y: 0 },
        exit: { x: 0, y: 0 },
    },
};
//# sourceMappingURL=directionMotion.js.map