export const fieldTypeDefaultConfigs = {
    date: {
        type: "date",
        options: {},
    },
    boolean: {
        type: "boolean",
        options: {},
    },
    expression: {
        type: "expression",
        options: {},
    },
    number: {
        type: "number",
        options: {},
    },
    string: {
        type: "string",
        options: {
            format: "text",
        },
    },
    action: {
        type: "action",
        label: "string",
        options: [
            {
                type: "none",
            },
        ],
    },
    state: {
        type: "state",
        options: {
            inputID: "input",
            type: "custom",
            field: { type: "string", options: { format: "text" } },
        },
    },
    relation: {
        type: "relation",
        options: {},
    },
    role: {
        type: "role",
        options: {},
    },
    "multiple-field": {
        type: "multiple-field",
        options: {
            fields: [],
        },
    },
    richtext: {
        type: "richtext",
        options: {},
    },
    variable: {
        type: "variable",
        options: {},
    },
    array: {
        type: "array",
        options: {
            format: "multiple-choices",
            options: [],
        },
    },
    custom: {
        type: "custom",
        options: {},
    },
    point: {
        type: "point",
        options: {},
    },
};
export const getDefaultFieldConfig = (type) => {
    return fieldTypeDefaultConfigs[type];
};
//# sourceMappingURL=fields.js.map