import { registerIntegration } from "../interfaces";
import TagManager from "react-gtm-module";
export default registerIntegration({
    name: "Google Tag Manager",
    group: "tracking",
    properties: {
        values: {
            GTM_ID: "GTM-XXXXXXX",
        },
        definitions: {
            GTM_ID: { type: "string", options: { format: "text" } },
        },
    },
}, (values) => {
    const tagManagerArgs = {
        gtmId: values.GTM_ID,
    };
    if (tagManagerArgs.gtmId !== "GTM-XXXXXXX") {
        TagManager.initialize(tagManagerArgs);
        return TagManager;
    }
    return null;
});
//# sourceMappingURL=gtm.js.map