import { jsx as _jsx } from "@emotion/react/jsx-runtime";
import { registerComponent } from "../interfaces";
import VStackComponent from "../components/VStack";
const VStack = registerComponent("VStack", {
    hidden: true,
    type: "none",
    icon: "IconTemplate",
    group: "layout",
    kind: "container",
    defaultProps: {
        padding: "2",
        background: "fill",
        length: "1",
        gap: "2",
    },
    propDefinition: {
        padding: {
            group: "Design",
            type: "string",
            options: {
                format: "select",
                options: [
                    { label: "Large", value: "6" },
                    { label: "Medium", value: "4" },
                    { label: "Small", value: "2" },
                    { label: "None", value: "0" },
                ],
            },
        },
        background: {
            group: "Design",
            type: "string",
            options: {
                format: "select",
                options: [
                    { label: "Fill", value: "fill" },
                    { label: "Transparent", value: "transparent" },
                ],
            },
        },
        gap: {
            group: "Design",
            type: "string",
            options: {
                format: "select",
                options: [
                    { label: "Large", value: "6" },
                    { label: "Medium", value: "4" },
                    { label: "Small", value: "2" },
                    { label: "None", value: "0" },
                ],
            },
        },
        length: { group: "Design", type: "string", options: { format: "text" } },
    },
    Component: (props) => _jsx(VStackComponent, Object.assign({}, props)),
});
export default VStack;
//# sourceMappingURL=buildVStack.js.map