import { extendTheme } from "@chakra-ui/react";
import { registerTheme } from ".";
import { getShades } from "./shadeCalculator";
export default registerTheme("Dark", extendTheme({
    colors: {
        auto: getShades("#171717"),
        bg: getShades("#272727"),
        text: getShades("#F1F1F1"),
        surface: getShades("#171717"),
        error: getShades("#E03138"),
        success: getShades("#329922"),
        info: getShades("#056CF2"),
        warning: getShades("#EE7105"),
    },
    fonts: {
        body: "system-ui, sans-serif",
        heading: "system-ui, sans-serif",
    },
    config: { initialColorMode: "dark", useSystemColorMode: false },
    styles: { global: { bg: "qore.bg_dark", color: "#FFFFFF" } },
    components: {
        Box: {
            baseStyle: { bg: "brand.900" },
        },
        Text: {
            baseStyle: {
                color: "#F1F1F1",
            },
        },
        Card: {
            baseStyle: { bg: "#0D0D0D" },
        },
        Button: {
            baseStyle: {
                color: "text.900",
                borderRadius: "8px",
            },
            variants: {
                ghost: {
                    bg: "qore.primary_lightest",
                    color: "brand.900",
                    _hover: { bg: "qore.primary_lightest" },
                    _active: { bg: "qore.primary_lightest" },
                },
                solid: {
                    bg: "brand.900",
                    _hover: { bg: "brand.900" },
                    _active: { bg: "brand.900" },
                },
            },
        },
    },
}));
//# sourceMappingURL=dark.js.map