import { jsx as _jsx, Fragment as _Fragment, jsxs as _jsxs } from "@emotion/react/jsx-runtime";
const RuntimeHead = ({ schema, manifestUrl, }) => {
    return (_jsxs(_Fragment, { children: [_jsx("title", { children: schema.name }), manifestUrl ? (_jsx("link", { rel: "manifest", href: manifestUrl })) : (schema.config.appID && (_jsx("link", { rel: "manifest", href: `/api/app/${schema.config.appID}/manifest.webmanifest` }))), _jsx("meta", { charSet: "utf-8" }), _jsx("meta", { httpEquiv: "X-UA-Compatible", content: "IE=edge" }), _jsx("meta", { name: "viewport", content: "width=device-width,initial-scale=1,minimum-scale=1,maximum-scale=1,user-scalable=no" }), _jsx("link", { href: schema.icon || "https://dashboard.qorebase.io/favicon-16x16.png", rel: "icon", type: "image/png", sizes: "16x16" }), _jsx("link", { href: schema.icon || "https://dashboard.qorebase.io/favicon-32x32.png", rel: "icon", type: "image/png", sizes: "32x32" }), _jsx("link", { rel: "apple-touch-icon", href: schema.icon || "https://dashboard.qorebase.io/apple-touch-icon.png" }), _jsx("meta", { name: "theme-color", content: schema.theme_color }), _jsx("meta", { name: "msapplication-TileColor", content: schema.theme_color }), _jsx("meta", { name: "title", content: schema.name }), _jsx("meta", { name: "description", content: schema.description }), _jsx("meta", { property: "og:type", content: "website" }), _jsx("meta", { property: "og:title", content: schema.name }), _jsx("meta", { property: "og:description", content: schema.description }), _jsx("meta", { property: "og:image", content: schema.icon }), _jsx("meta", { property: "twitter:card", content: "summary_large_image" }), _jsx("meta", { property: "twitter:title", content: schema.name }), _jsx("meta", { property: "twitter:description", content: schema.description }), _jsx("meta", { property: "twitter:image", content: schema.icon }), _jsx("meta", { name: "mobile-web-app-capable", content: "yes" }), _jsx("meta", { name: "apple-touch-fullscreen", content: "yes" }), _jsx("meta", { name: "apple-mobile-web-app-title", content: schema.name }), _jsx("meta", { name: "apple-mobile-web-app-capable", content: "yes" }), _jsx("meta", { name: "apple-mobile-web-app-status-bar-style", content: "black-translucent" })] }));
};
export default RuntimeHead;
//# sourceMappingURL=RuntimeHead.js.map